local assets=
{
	Asset("ANIM", "anim/godstick.zip"),
	Asset("ANIM", "anim/swap_godstick.zip"),
        Asset("IMAGE", "images/inventoryimages/godstick.tex"),
        Asset("ATLAS", "images/inventoryimages/godstick.xml"),
}

--[[local function onfinished(inst)
    inst:Remove()
end]]

local function onequip(inst, owner) 
    owner.AnimState:OverrideSymbol("swap_object", "swap_godstick", "swap_spear")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
    inst.Transform:SetScale(3, 3, 3)
    GetPlayer().components.combat.min_attack_period =.05
    inst.Light:Enable(true)
    GetPlayer().components.temperature:SetTemp(36)
    GetPlayer():PushEvent("stopfreezing")
    GetPlayer():PushEvent("stopoverheating")
    GetPlayer().components.moisture:SetMoistureLevel(0)
    GetPlayer().components.health.absorb =.95
    GetPlayer().components.health.fire_damage_scale =1
    GetPlayer():AddTag("SB") 
    if GetPlayer():HasTag("SB") then
    inst:DoPeriodicTask(1, function(inst)
        local pos2 = Vector3(inst.Transform:GetWorldPosition())
        local ents2 = TheSim:FindEntities(pos2.x,pos2.y,pos2.z, 25)
        for k,e in pairs(ents2) do
            if e:HasTag("player") then
               e.components.health:DoDelta(50)
               e.components.sanity:DoDelta(50)
            end
        end
    end )
 end
end

local function onunequip(inst, owner) 
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
    GetPlayer().components.combat.min_attack_period =0.5
    inst.Light:Enable(false)
    GetPlayer().components.temperature:SetTemp(nil)
    GetPlayer().components.health.absorb =0
    GetPlayer().components.health.fire_damage_scale =0
    if GetPlayer():HasTag("SB") then
    --[[inst:DoPeriodicTask(1, function(inst)
        local pos6 = Vector3(inst.Transform:GetWorldPosition())
        local ents6 = TheSim:FindEntities(pos6.x,pos6.y,pos6.z, 25)
        for k,g in pairs(ents6) do
            if g:HasTag("player") then
               g.components.health:DoDelta(-50)
               g.components.sanity:DoDelta(-50)
            end
        end
    end )]]
    GetPlayer():RemoveTag("SB")
 end
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    MakeInventoryPhysics(inst)
    
    anim:SetBank("spear")
    --anim:SetBank("livinglog")
    anim:SetBuild("godstick")
    anim:PlayAnimation("idle")
    
    inst.Transform:SetScale(5, 5, 5)
    MakeObstaclePhysics( inst, 2)
    inst:AddTag("sharp")
    
    local minimap = inst.entity:AddMiniMapEntity()
	    minimap:SetIcon( "godstick.tex" )
    
    inst:AddComponent("tool")
    inst.components.tool:SetAction(ACTIONS.CHOP, 15)
    inst.components.tool:SetAction(ACTIONS.MINE, 15)
    inst.components.tool:SetAction(ACTIONS.HAMMER)
    inst.components.tool:SetAction(ACTIONS.DIG)
    inst.components.tool:SetAction(ACTIONS.NET)
    inst.components.tool:SetAction(ACTIONS.PLAY)
    
    inst:AddComponent("waterproofer")
    inst.components.waterproofer:SetEffectiveness(1)

    local light = inst.entity:AddLight()
    light:SetFalloff(0.4)
    light:SetIntensity(.7)
    light:SetRadius(25)
    light:SetColour(180/255, 195/255, 150/255)
    light:Enable(true)
    
     local function disable(inst)
        if inst.updatetask then
            inst.updatetask:Cancel()
            inst.updatetask = nil
        end
        local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
        if owner and owner.components.leader then
            --owner:RemoveTag("rocky")
            for k,v in pairs(owner.components.leader.followers) do
                if k:HasTag("monster") and k.components.combat then
                    k.components.combat:SuggestTarget(owner)
                end
            end
           -- owner.components.leader:RemoveFollowersByTag("spider")
        end
    end
    local function update(inst)
        local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
        if owner and owner.components.leader then
	--owner:AddTag("rocky")
            --owner.components.leader:RemoveFollowersByTag("pig")
            local x,y,z = owner.Transform:GetWorldPosition()
            local ents = TheSim:FindEntities(x,y,z,--[[ TUNING.SPIDERHAT_RANGE]]25--[[, {"monster"}]])
            for k,v in pairs(ents) do
                if v:HasTag("rocky") or v:HasTag("pig") or v:HasTag("animal") or v:HasTag("spider") --[[or v:HasTag("manrabbit") ]]and v.components.follower and not v.components.follower.leader and not owner.components.leader:IsFollower(v) then
                    owner.components.leader:AddFollower(v)
                end
            end
        end
    end
    local function enable(inst)
        local owner = inst.components.inventoryitem and inst.components.inventoryitem.owner
        if owner and owner.components.leader then
           -- owner.components.leader:RemoveFollowersByTag("spider")
            --owner:AddTag("rocky")
        end
        inst.updatetask = inst:DoPeriodicTask(0.5, update, 1)
    end
    
        local function equip(inst, owner)
        onequip(inst, owner)
        enable(inst)
    end
    local function unequip(inst, owner)
        onunequip(inst, owner)
        disable(inst)
    end

    --[[inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(100)
    inst.components.finiteuses:SetUses(100)
    
    inst.components.finiteuses:SetOnFinished( onfinished )]]
   local function onattack(inst, owner, target)
    local pos = Vector3(inst.Transform:GetWorldPosition())
    local ents = TheSim:FindEntities(pos.x,pos.y,pos.z, 50)
    for k,v in pairs(ents) do
        if v.components.health  and v.components.combat and not v.components.health:IsDead() --[[and not v:HasTag("shadowcreature")]] then
           if v.components.combat.target == GetPlayer() or GetPlayer().components.combat.target == v or v:HasTag("monster") then
              inst.components.weapon:LaunchProjectile(inst, v)
              v.components.health:DoDelta(-500)
        if  v.components.freezable and v.components.freezable:IsFrozen() then
            v.components.freezable:Unfreeze()
	end            
        if v.components.sleeper and v.components.sleeper:IsAsleep() then
          v.components.sleeper:WakeUp()
	     end
	   end
	 end
       end
   end

local function turnon(inst)
    inst.components.machine.ison = true
    inst.task = inst:DoPeriodicTask(.5, function() onattack(inst) end)
    end
local function turnoff(inst)
    inst.components.machine.ison = false
    if inst.task then inst.task:Cancel() inst.task = nil end
end
    inst:AddComponent("machine")
    inst.components.machine.turnonfn = turnon
    inst.components.machine.turnofffn = turnoff
 
TheInput:AddKeyUpHandler(KEY_F1, function()
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  --  ȫ ͼ", 4, false) 
       local map = TheSim:FindFirstEntityWithTag("minimap")
       local x,y,z = GetPlayer().Transform:GetWorldPosition()
       map.MiniMap:ShowArea(x, y, z, 10000)
    --end
end) 
    
TheInput:AddKeyUpHandler(KEY_F2, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  --    ", 4, false) 
GetPlayer().components.builder:GiveAllRecipes()
 --end  
end )

TheInput:AddKeyUpHandler(KEY_F3, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  --   ", 4, false)
if GetPlayer().components.health then
   GetPlayer().components.health:SetInvincible(true)
if GetPlayer().components.hunger then
   GetPlayer().components.hunger:Pause()
   end
 end
--end  
end )
 
TheInput:AddKeyUpHandler(KEY_F5, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  --  ", 4, false) 
inst:DoTaskInTime(0.1, function()
    local pos3 = Vector3(inst.Transform:GetWorldPosition())
    local ents3 = TheSim:FindEntities(pos3.x,pos3.y,pos3.z, 25)
    for k,c in pairs(ents3) do
          if c.components.freezable and not c:HasTag("player") then
            c.components.freezable:AddColdness(5)
            c.components.freezable:SpawnShatterFX()
        end
          if c.components.sleeper and c.components.sleeper:IsAsleep() then
            c.components.sleeper:WakeUp()
        end
          if c.components.burnable and c.components.burnable:IsBurning() then
            c.components.burnable:Extinguish()
        end
     end 
   end )      
 --end   
end ) 
 
TheInput:AddKeyUpHandler(KEY_F4, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  --  ", 4, false) 
inst:DoTaskInTime(0.1, function()
    local pos4 = Vector3(inst.Transform:GetWorldPosition())
    local ents4 = TheSim:FindEntities(pos4.x,pos4.y,pos4.z, 25)
    for k,d in pairs(ents4) do
	if d.components.burnable and not d.components.burnable:IsBurning() and not d:HasTag("player") then
        if d.components.freezable and d.components.freezable:IsFrozen() then           
	   d.components.freezable:Unfreeze()            
        else            
	   d.components.burnable:Ignite(true)
        end   
      end
    if d.components.freezable then
        d.components.freezable:AddColdness(-1) 
        if d.components.freezable:IsFrozen() then
            d.components.freezable:Unfreeze()            
        end
    end
    if d.components.sleeper and d.components.sleeper:IsAsleep() then
        d.components.sleeper:WakeUp()
    end
     end  
   end ) 
 --end
end ) 
    
TheInput:AddKeyUpHandler(KEY_F6, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  -- Զ   ", 4, false)
if GetPlayer().components.combat then
GetPlayer().components.combat:SetRange(30, 35)
  end
 --end
end ) 

TheInput:AddKeyUpHandler(KEY_F7, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  -- һ   ժ", 4, false) 
 inst:DoTaskInTime(0.1, function() 
    local pos8 = Vector3(inst.Transform:GetWorldPosition())
    local ents8 = TheSim:FindEntities(pos8.x,pos8.y,pos8.z, 25)
    for k,h in pairs(ents8) do
        if h.components.pickable and h.prefab ~= "flower" then
           h.components.pickable:Pick(GetPlayer())
        end
        if h.components.crop then
           h.components.crop:Harvest(GetPlayer())
        end
    end
 end )  
 --end
end ) 

TheInput:AddKeyUpHandler(KEY_F8, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  -- Զ    Ʒ", 4, false)
 inst:DoTaskInTime(0.1, function() 
local function getitem(player, amulet, item)
    --SpawnEffect(item)
    if item.components.stackable then
        item = item.components.stackable:Get()
    end
    
    if item.components.trap and item.components.trap:IsSprung() then
        item.components.trap:Harvest(player)
        return
    end
    
    player.components.inventory:GiveItem(item)
end

    local pt = Vector3(inst.Transform:GetWorldPosition())
    local ents9 = TheSim:FindEntities(pt.x, pt.y, pt.z, 25)
    for k,j in pairs(ents9) do
        if j.components.inventoryitem and j.components.inventoryitem.canbepickedup and j.components.inventoryitem.cangoincontainer and not
            j.components.inventoryitem:IsHeld() and not j:HasTag("trap") and not j:HasTag("light") and not j:HasTag("blowdart") and not j:HasTag("projectile") then

            if not GetPlayer().components.inventory:IsFull() then
                getitem(GetPlayer(), inst, j)
                return

            elseif j.components.stackable then
                local stack = GetPlayer().components.inventory:FindItem(function(item) return (item.prefab == j.prefab and not item.components.stackable:IsFull()
                    and item ~= GetPlayer().components.inventory.activeitem) end)
                if stack then
                    getitem(GetPlayer(), inst, j)
                    return
                end
            end
        end
    end
 end )  
 --end
end ) 

TheInput:AddKeyUpHandler(KEY_F9, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  -- ֲ     ", 4, false) 
    local pos9 = Vector3(inst.Transform:GetWorldPosition())
    local ents10 = TheSim:FindEntities(pos9.x,pos9.y,pos9.z, 25)
    for k,k in pairs(ents10) do
        if k.components.pickable then
           k.components.pickable:FinishGrowing()
        end
        if k.components.crop then
           k.components.crop:DoGrow(TUNING.TOTAL_DAY_TIME*3)
        end
        if k:HasTag("tree") and k.components.growable and not k:HasTag("stump") then
           k.components.growable:DoGrowth()
        end
    end
 --end
end ) 

TheInput:AddKeyUpHandler(KEY_F10, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  --  һ ʱ  ", 4, false) 
GetClock():NextPhase()
 --end
end ) 

TheInput:AddKeyUpHandler(KEY_F11, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  --  һ ", 4, false) 
GetClock():MakeNextDay()
 --end
end ) 

TheInput:AddKeyUpHandler(KEY_F12, function() 
--if TheInput:IsKeyDown(KEY_CTRL) then
GetPlayer().components.talker:Say("S B ֮  --  ɱ ", 4, false) 
 inst:DoTaskInTime(0.1, function() 
	local pos7 = Vector3(inst.Transform:GetWorldPosition())
	local ents7 = TheSim:FindEntities(pos7.x,pos7.y,pos7.z, 25)
	for k,i in pairs(ents7) do
	if i.components.combat and i.components.health and not i.components.health:IsDead() and not i:HasTag("player") then
	SpawnPrefab("ground_chunks_breaking").Transform:SetPosition(i.Transform:GetWorldPosition())
	i.components.health:Kill()
	end
	if i.components.workable and i.components.workable.workleft > 0 and not i.components.inventoryitem then
	SpawnPrefab("ground_chunks_breaking").Transform:SetPosition(i.Transform:GetWorldPosition())
	i.components.workable:Destroy(i)
	end
	GetPlayer().SoundEmitter:PlaySound("dontstarve_DLC001/creatures/glommer/foot_ground")
	SpawnPrefab("collapse_big").Transform:SetPosition(i.Transform:GetWorldPosition())
	SpawnPrefab("explode_small").Transform:SetPosition(i.Transform:GetWorldPosition())
	SpawnPrefab("groundpoundring_fx").Transform:SetPosition(i.Transform:GetWorldPosition())
	GetClock():DoLightningLighting()
	GetPlayer().components.playercontroller:ShakeCamera(i, "FULL", 0.7, 0.02, .5, 40)
	--i:Remove()
      end
    end )
 --end
end )   
  
local function onattack2(inst, owner, target)
GetPlayer().components.talker:Say("    S B    !", 4, false)
    GetClock():DoLightningLighting()
    GetPlayer().SoundEmitter:PlaySound("dontstarve_DLC001/creatures/glommer/foot_ground")
    GetPlayer().components.playercontroller:ShakeCamera(inst, "FULL", 0.7, 0.02, .5, 40)
    --local pos5 = Vector3(inst.Transform:GetWorldPosition())
    --local ents5 = TheSim:FindEntities(pos5.x,pos5.y,pos5.z, 5)
    --for k,f in pairs(ents5) do
    --if  not f.HasTag("player") then
	--inst.components.weapon:LaunchProjectile(inst, f)
	--f.components.health:DoDelta(-199)
     --end
   --end
 end
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(200)
    --inst.components.weapon:SetRange(4, 5)
    inst.components.weapon:SetOnAttack(onattack2)
    inst.components.weapon:SetProjectile("sb_charge")
    
    --inst:AddComponent("combat")
    --inst.components.combat:SetAttackPeriod(5)
    
    inst:AddComponent("blinkstaff")
    
    inst:AddComponent("cooker")
    
    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname="images/inventoryimages/godstick.xml"
    inst:AddTag("flute")
    local function HearPanFlute(inst, musician, instrument)
    if inst.components.sleeper then
       inst.components.sleeper:AddSleepiness(10, TUNING.PANFLUTE_SLEEPTIME*3)
    end
end
    inst:AddComponent("instrument")
    inst.components.instrument.range = TUNING.PANFLUTE_SLEEPRANGE*2
    inst.components.instrument:SetOnHeardFn(HearPanFlute)
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(equip)
    inst.components.equippable:SetOnUnequip(unequip)
    inst.components.equippable.walkspeedmult =2
    
    return inst
end

return Prefab( "common/inventory/godstick", fn, assets) 
